#ifndef __Config
#define __Config

#include <Arduino.h>
#include <stdint.h>
#include "credentials.h"


//#define SerialDebug


// The name of this device on the network
static const char* WiFiHostname = "Stairs";


// The number of steps (assumed to be <= 16, as the code currently only controls 1 PCA9685 board)
static const uint8_t StepCount = 14;


// The port number on which the UDP server listens
static const uint16_t UDPPort = 3126;


// Pins for the I2C bus
static const uint8_t PinSDA = 13;
static const uint8_t PinSCL = 12;


// I2C address and PWM frequency of the PCA9685 board
static const uint8_t PWMDriverAddress = 0x40;
static const uint16_t PWMDriverPWMFrequency = 1600;


// Determines if OTA firmware updates are enabled
// 0 - Disabled
// 1 - Enabled (fixed URL)
// 2 - Enabled (use URL in command)
static const uint8_t OTAUpdateEnabled = 2;

static const char* OTAUpdateFixedHost = "";
static const uint16_t OTAUpdateFixedPort = 80;
static const char* OTAUpdateFixedPath = "/";

// The minimum amount of time (in milliseconds) between update requests
static const uint32_t OTAUpdateThrottle = 5000;


#ifdef SerialDebug
#define _d(msg) Serial.print(msg)
#define _dln(msg) Serial.println(msg)
#else
#define _d(msg) do { } while (0)
#define _dln(msg) do { } while (0)
#endif

#endif