#ifndef __AlternateMode
#define __AlternateMode

#include <stdint.h>
#include "base.h"
#include "../config.h"


struct AlternateModeParameters
{
    uint16_t interval;
    uint16_t brightness;
};


class AlternateMode : public BaseMode<AlternateModeParameters>
{
  private:
    uint32_t lastChange;
    bool even = false;

  public:
    AlternateMode()
    {
      parameters.interval = 500;
      parameters.brightness = IStairs::On;
    }

    void init(IStairs* stairs, uint32_t currentTime);
    void tick(IStairs* stairs, uint32_t currentTime);
};

#endif